---
apiVersion: v1
kind: Secret
metadata:
  name: mongo
type: Opaque
data:
  mongo_uri: {{ _mongo_uri_ |  b64encode }}
---
kind: Secret
apiVersion: v1
type: kubernetes.io/dockercfg
metadata:
  name: docker-registry
data:
  .dockercfg: eyJyZWdpc3RyeS5naXRsYWIuY29tIjp7ImF1dGgiOiJaV3B2Y3pwQmVVSnlWbkpZVjBZMVNrRldVR1pqVkhsQ1FRPT0ifX0=
---
  apiVersion: apps/v1
  kind: Deployment
  metadata:
    name: bibliotheca
  spec:
    selector:
      matchLabels:
        app: bibliotheca
    replicas: 2
    strategy:
      type: RollingUpdate
      rollingUpdate:
        maxUnavailable: "40%"
        maxSurge: "50%"
    template:
      metadata:
        labels:
          app: bibliotheca
      spec:
        imagePullSecrets: 
        - name: docker-registry
        containers:
        - name: app
          image: registry.gitlab.com/ejos/k8s-nodejs-mongodb:latest
          imagePullPolicy: Always
          resources:
            requests:
              memory: "64Mi"
              cpu: "100m"
            limits:
              memory: "128Mi"
              cpu: "100m"
          env:
            - name: PORT
              value: "3000"
            - name: MONGODB_URI
              valueFrom:
                  secretKeyRef:
                     name: mongo
                     key: mongo_uri
          ports:
             - name: nodejs-port
               containerPort: 3000
---
apiVersion: v1
kind: Service
metadata:
  name: bibliotheca
spec:
  ports:
  - name: http
    port: 3000
    targetPort: nodejs-port
    protocol: TCP
  selector:
    app: bibliotheca
  type: LoadBalancer
  externalIPs:
  - ansible_default_ipv4.address
